Update nginx-proxy-manager-install.sh

pull/166/head
tteckster 2022-04-18 08:00:11 -04:00 committed by GitHub
parent 4f2aa20a73
commit 9b183c7bd8
No known key found for this signature in database
GPG Key ID: 4AEE18F83AFDEB23
1 changed files with 52 additions and 61 deletions

View File

@ -1,38 +1,30 @@
#!/usr/bin/env bash #!/usr/bin/env bash -ex
set -euo pipefail
set -o errexit shopt -s inherit_errexit nullglob
set -o errtrace YW=`echo "\033[33m"`
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR
trap 'die "Script interrupted."' INT
function error_exit() {
trap - ERR
local DEFAULT='Unknown failure occured.'
local REASON="\e[97m${1:-$DEFAULT}\e[39m"
local FLAG="\e[91m[ERROR:LXC] \e[93m$EXIT@$LINE"
msg "$FLAG $REASON"
exit $EXIT
}
function msg() {
local TEXT="$1"
echo -e "$TEXT"
}
RD=`echo "\033[01;31m"` RD=`echo "\033[01;31m"`
BL=`echo "\033[36m"` BL=`echo "\033[36m"`
GN=`echo "\033[1;92m"` GN=`echo "\033[1;92m"`
CL=`echo "\033[m"` CL=`echo "\033[m"`
CM="${GN}${CL}"
CROSS="${RD}${CL}"
RETRY_NUM=10 RETRY_NUM=10
RETRY_EVERY=3 RETRY_EVERY=3
NUM=$RETRY_NUM NUM=$RETRY_NUM
CM="${GN}${CL}"
CROSS="${RD}${CL}"
BFR="\\r\\033[K"
HOLD="-"
echo -en "${GN} Setting up Container OS... " function msg_info() {
local msg="$1"
echo -ne " ${HOLD} ${YW}${msg}..."
}
function msg_ok() {
local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
}
msg_info "Setting up Container OS "
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do while [ "$(hostname -I)" = "" ]; do
@ -45,16 +37,15 @@ while [ "$(hostname -I)" = "" ]; do
exit 1 exit 1
fi fi
done done
echo -e "${CM}${CL} \r" msg_ok "Set up Container OS"
echo -en "${GN} Network Connected: ${BL}$(hostname -I)${CL} " msg_ok "Network Connected: ${BL}$(hostname -I)"
echo -e "${CM}${CL} \r"
echo -en "${GN} Updating Container OS... " msg_info "Updating Container OS"
apt update &>/dev/null apt update &>/dev/null
apt-get -qqy upgrade &>/dev/null apt-get -qqy upgrade &>/dev/null
echo -e "${CM}${CL} \r" msg_ok "Updated Container OS"
echo -en "${GN} Installing Dependencies... " msg_info "Installing Dependencies"
apt-get update &>/dev/null apt-get update &>/dev/null
apt-get -qqy install \ apt-get -qqy install \
sudo \ sudo \
@ -69,9 +60,9 @@ apt-get -qqy install \
python3-dev \ python3-dev \
git \ git \
lsb-release &>/dev/null lsb-release &>/dev/null
echo -e "${CM}${CL} \r" msg_ok "Installed Dependencies"
echo -en "${GN} Installing Python... " msg_info "Installing Dependencies"
apt-get install -y -q --no-install-recommends python3 python3-pip python3-venv &>/dev/null apt-get install -y -q --no-install-recommends python3 python3-pip python3-venv &>/dev/null
pip3 install --upgrade setuptools &>/dev/null pip3 install --upgrade setuptools &>/dev/null
pip3 install --upgrade pip &>/dev/null pip3 install --upgrade pip &>/dev/null
@ -80,38 +71,38 @@ echo -e "${CM}${CL} \r"
python3 -m pip install --no-cache-dir -U cryptography==3.3.2 &>/dev/null python3 -m pip install --no-cache-dir -U cryptography==3.3.2 &>/dev/null
fi fi
python3 -m pip install --no-cache-dir cffi certbot &>/dev/null python3 -m pip install --no-cache-dir cffi certbot &>/dev/null
echo -e "${CM}${CL} \r" msg_ok "Installed Dependencies"
echo -en "${GN} Installing Openresty... " msg_info "Installing Openresty"
wget -q -O - https://openresty.org/package/pubkey.gpg | apt-key add - &>/dev/null wget -q -O - https://openresty.org/package/pubkey.gpg | apt-key add - &>/dev/null
codename=`grep -Po 'VERSION="[0-9]+ \(\K[^)]+' /etc/os-release` &>/dev/null codename=`grep -Po 'VERSION="[0-9]+ \(\K[^)]+' /etc/os-release` &>/dev/null
echo "deb http://openresty.org/package/debian $codename openresty" | tee /etc/apt/sources.list.d/openresty.list &>/dev/null echo "deb http://openresty.org/package/debian $codename openresty" | tee /etc/apt/sources.list.d/openresty.list &>/dev/null
apt-get -y update &>/dev/null apt-get -y update &>/dev/null
apt-get -y install --no-install-recommends openresty &>/dev/null apt-get -y install --no-install-recommends openresty &>/dev/null
echo -e "${CM}${CL} \r" msg_ok "Installed Openresty"
echo -en "${GN} Setting up Node.js Repository... " msg_info "Setting up Node.js Repository"
sudo curl -sL https://deb.nodesource.com/setup_16.x | sudo -E bash - &>/dev/null sudo curl -sL https://deb.nodesource.com/setup_16.x | sudo -E bash - &>/dev/null
echo -e "${CM}${CL} \r" msg_ok "Set up Node.js Repository"
echo -en "${GN} Installing Node.js... " msg_info "Installing Node.js"
sudo apt-get install -y nodejs git make g++ gcc &>/dev/null sudo apt-get install -y nodejs git make g++ gcc &>/dev/null
echo -e "${CM}${CL} \r" msg_ok "Installed Node.js"
echo -en "${GN} Installing Yarn... " msg_info "Installing Yarn"
npm install --global yarn &>/dev/null npm install --global yarn &>/dev/null
echo -e "${CM}${CL} \r" msg_ok "Installed Yarn"
RELEASE=$(curl -s https://api.github.com/repos/NginxProxyManager/nginx-proxy-manager/releases/latest \ RELEASE=$(curl -s https://api.github.com/repos/NginxProxyManager/nginx-proxy-manager/releases/latest \
| grep "tag_name" \ | grep "tag_name" \
| awk '{print substr($2, 3, length($2)-4) }') \ | awk '{print substr($2, 3, length($2)-4) }') \
echo -en "${GN} Downloading NPM v${RELEASE}... " msg_info "Downloading Nginx Proxy Manager v${RELEASE}"
wget -q https://codeload.github.com/NginxProxyManager/nginx-proxy-manager/tar.gz/v${RELEASE} -O - | tar -xz &>/dev/null wget -q https://codeload.github.com/NginxProxyManager/nginx-proxy-manager/tar.gz/v${RELEASE} -O - | tar -xz &>/dev/null
cd ./nginx-proxy-manager-${RELEASE} cd ./nginx-proxy-manager-${RELEASE}
echo -e "${CM}${CL} \r" msg_ok "Downloaded Nginx Proxy Manager v${RELEASE}"
echo -en "${GN} Setting up Enviroment... " msg_info "Setting up Enviroment"
ln -sf /usr/bin/python3 /usr/bin/python ln -sf /usr/bin/python3 /usr/bin/python
ln -sf /usr/bin/certbot /opt/certbot/bin/certbot ln -sf /usr/bin/certbot /opt/certbot/bin/certbot
ln -sf /usr/local/openresty/nginx/sbin/nginx /usr/sbin/nginx ln -sf /usr/local/openresty/nginx/sbin/nginx /usr/sbin/nginx
@ -155,7 +146,7 @@ chmod -R 777 /var/cache/nginx
chown root /tmp/nginx chown root /tmp/nginx
echo resolver "$(awk 'BEGIN{ORS=" "} $1=="nameserver" {print ($2 ~ ":")? "["$2"]": $2}' /etc/resolv.conf);" > /etc/nginx/conf.d/include/resolvers.conf echo resolver "$(awk 'BEGIN{ORS=" "} $1=="nameserver" {print ($2 ~ ":")? "["$2"]": $2}' /etc/resolv.conf);" > /etc/nginx/conf.d/include/resolvers.conf
echo -e "${CM}${CL} \r"
if [ ! -f /data/nginx/dummycert.pem ] || [ ! -f /data/nginx/dummykey.pem ]; then if [ ! -f /data/nginx/dummycert.pem ] || [ ! -f /data/nginx/dummykey.pem ]; then
echo -en "${GN} Generating dummy SSL Certificate... " echo -en "${GN} Generating dummy SSL Certificate... "
openssl req -new -newkey rsa:2048 -days 3650 -nodes -x509 -subj "/O=Nginx Proxy Manager/OU=Dummy Certificate/CN=localhost" -keyout /data/nginx/dummykey.pem -out /data/nginx/dummycert.pem &>/dev/null openssl req -new -newkey rsa:2048 -days 3650 -nodes -x509 -subj "/O=Nginx Proxy Manager/OU=Dummy Certificate/CN=localhost" -keyout /data/nginx/dummykey.pem -out /data/nginx/dummycert.pem &>/dev/null
@ -164,18 +155,18 @@ fi
mkdir -p /app/global /app/frontend/images mkdir -p /app/global /app/frontend/images
cp -r backend/* /app cp -r backend/* /app
cp -r global/* /app/global cp -r global/* /app/global
echo -e "${CM}${CL} \r" msg_ok "Set up Enviroment"
echo -en "${GN} Building Frontend... " msg_info "Building Frontend"
cd ./frontend cd ./frontend
export NODE_ENV=development export NODE_ENV=development
yarn install --network-timeout=30000 &>/dev/null yarn install --network-timeout=30000 &>/dev/null
yarn build &>/dev/null yarn build &>/dev/null
cp -r dist/* /app/frontend cp -r dist/* /app/frontend
cp -r app-images/* /app/frontend/images cp -r app-images/* /app/frontend/images
echo -e "${CM}${CL} \r" msg_ok "Built Frontend"
echo -en "${GN} Initializing Backend... " msg_info "Initializing Backend"
rm -rf /app/config/default.json &>/dev/null rm -rf /app/config/default.json &>/dev/null
if [ ! -f /app/config/production.json ]; then if [ ! -f /app/config/production.json ]; then
cat << 'EOF' > /app/config/production.json cat << 'EOF' > /app/config/production.json
@ -195,9 +186,9 @@ fi
cd /app cd /app
export NODE_ENV=development export NODE_ENV=development
yarn install --network-timeout=30000 &>/dev/null yarn install --network-timeout=30000 &>/dev/null
echo -e "${CM}${CL} \r" msg_ok "Initialized Backend"
echo -en "${GN} Creating NPM Service... " msg_info "Creating Service"
cat << 'EOF' > /lib/systemd/system/npm.service cat << 'EOF' > /lib/systemd/system/npm.service
[Unit] [Unit]
Description=Nginx Proxy Manager Description=Nginx Proxy Manager
@ -215,11 +206,11 @@ Restart=on-failure
[Install] [Install]
WantedBy=multi-user.target WantedBy=multi-user.target
EOF EOF
echo -e "${CM}${CL} \r" msg_ok "Created Service"
PASS=$(grep -w "root" /etc/shadow | cut -b6); PASS=$(grep -w "root" /etc/shadow | cut -b6);
if [[ $PASS != $ ]]; then if [[ $PASS != $ ]]; then
echo -en "${GN} Customizing Container... " msg_info "Customizing Container"
rm /etc/motd rm /etc/motd
rm /etc/update-motd.d/10-uname rm /etc/update-motd.d/10-uname
touch ~/.hushlogin touch ~/.hushlogin
@ -232,17 +223,17 @@ ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,3840
EOF EOF
systemctl daemon-reload systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//') systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
echo -e "${CM}${CL} \r" msg_ok "Customized Container"
fi fi
echo -en "${GN} Starting Services... " msg_info "Starting Services"
systemctl enable npm &>/dev/null systemctl enable npm &>/dev/null
systemctl start openresty systemctl start openresty
systemctl start npm systemctl start npm
echo -e "${CM}${CL} \r" msg_ok "Started Services"
echo -en "${GN} Cleanup... " msg_info "Cleaning up"
apt-get autoremove >/dev/null apt-get autoremove >/dev/null
apt-get autoclean >/dev/null apt-get autoclean >/dev/null
rm -rf /var/{cache,log}/* /var/lib/apt/lists/* rm -rf /var/{cache,log}/* /var/lib/apt/lists/*
echo -e "${CM}${CL} \n" msg_ok "Cleaned"